//+------------------------------------------------------------------+ 
//|                                             TrendStrengthEVO.mq4 | 
//|                                                                  | 
//|                                                                  | 
//|                                               modified by nnjeim |
//|                                               further by ecnonome|
//+------------------------------------------------------------------+ 
#property copyright "forex-tsd" 
#property link      "http://www.forex-tsd.com" 

#property indicator_separate_window 
#property indicator_buffers 2 

#property indicator_color1 Lime 
#property indicator_color2 Crimson 

#property indicator_level1 0

extern int LMAper=20;
extern int MMAper=10;
extern int SMAper=5;

extern int LMApri=4;
extern int MMApri=0;
extern int SMApri=4;

extern int LMAmet=25;
extern int MMAmet=23;
extern int SMAmet=23;

extern string  PriceMode    = "";
extern string  _0           = "Close";
extern string  _1           = "Open";
extern string  _2           = "High";
extern string  _3           = "Low";
extern string  _4           = "Median";
extern string  _5           = "Typical";
extern string  _6           = "Weighted Close";
extern string  _7           = "Heiken Ashi Close";
extern string  _8           = "Heiken Ashi Open";
extern string  _9           = "Heiken Ashi High";
extern string  _10          = "Heiken Ashi Low";
extern string  MAMode       = "";
extern string  __0          = "SMA";
extern string  __1          = "EMA";
extern string  __2          = "Wilder";
extern string  __3          = "LWMA";
extern string  __4          = "SineWMA";
extern string  __5          = "TriMA";
extern string  __6          = "LSMA";
extern string  __7          = "SMMA";
extern string  __8          = "HMA";
extern string  __9          = "ZeroLagEMA";
extern string  __10         = "DEMA";
extern string  __11         = "T3 basic";
extern string  __12         = "ITrend";
extern string  __13         = "Median";
extern string  __14         = "GeoMean";
extern string  __15         = "REMA";
extern string  __16         = "ILRS";
extern string  __17         = "IE/2";
extern string  __18         = "TriMAgen";
extern string  __19         = "VWMA";
extern string  __20         = "JSmooth";
extern string  __21         = "SMA_eq";
extern string  __22         = "ALMA";
extern string  __23         = "TEMA";
extern string  __24         = "T3";
extern string  __25         = "Laguerre";
extern string  __26         = "MD";


double ExtMapBuffer1[];
double ExtMapBuffer2[];
double AVE[];
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
   IndicatorBuffers(3);  

   IndicatorShortName("TrendStrength EVO"); 
    
   SetIndexBuffer(0,ExtMapBuffer1); 
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 2); 
   SetIndexDrawBegin(0,2); 
   SetIndexLabel(0,"ExtMapBuffer1");   
   
   SetIndexBuffer(1,ExtMapBuffer2); 
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2); 
   SetIndexDrawBegin(1,2); 
   SetIndexLabel(1,"ExtMapBuffer2");   

   SetIndexBuffer(2,AVE);              
//---- indicators 
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
  { 
//---- TODO: add your code here 
    
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   int    shift,counted_bars=IndicatorCounted(); 
   double  ma1, ma2, ma3; 
               

  //---- check for possible errors 
     if(counted_bars<0) return(-1); 
  //---- last counted bar will be recounted 
     if(counted_bars>0) counted_bars--; 
   shift=Bars-1; 
   while(shift>=0) 
     {
     
   ma1=iCustom(NULL, NULL, "!     ! AllAverages_v3.1",0,SMApri,SMAper,0,SMAmet,1,0,0,"alert.wav","alert2.wav",0,shift);     
   ma2=ma1-iCustom(NULL, NULL, "!     ! AllAverages_v3.1",0,MMApri,MMAper,0,MMAmet,1,0,0,"alert.wav","alert2.wav",0,shift);
   ma3=ma1-iCustom(NULL, NULL, "!     ! AllAverages_v3.1",0,LMApri,LMAper,0,LMAmet,1,0,0,"alert.wav","alert2.wav",0,shift);
         
         
   AVE[shift]=(ma2+ma3)/2;
            
    if (AVE[shift]>AVE[shift+1]) 
     {
     ExtMapBuffer1[shift]=AVE[shift]; 
     ExtMapBuffer2[shift]=0;
     }
     else 
     {
     ExtMapBuffer2[shift]=AVE[shift];
     ExtMapBuffer1[shift]=0;
     }   
     shift--;// 
     } 
         
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 

